﻿package 
{
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.events.Event;
	import flash.geom.Point;
	import fl.motion.Color;
	import flash.display.MovieClip;
	import flash.geom.ColorTransform;
	import com.greensock.*;
	import com.greensock.plugins.*;

	public class Momemtumconservation extends Sprite
	{
		private var balls:Array;
		private var numBalls:uint = 20;
		private var bounce:Number = -1.0;
		private var canvas:Sprite;

		public function Momemtumconservation()
		{
			init();
		}

		private function init():void
		{
			TweenPlugin.activate([TintPlugin]);
			
			canvas = new Sprite();
			addChild(canvas);
			balls = new Array();
			for (var i:uint = 0; i<numBalls; i++)
			{
				//var color:uint = 0x000000 + Math.random() * 0xFFFFFF;
				var color:uint = 0xFFFFFF;
				var radius:Number = Math.random() * 15 + 5;
				var ball:Ball = new Ball(radius,color);
				ball.mass = ball.radius;
				ball.x = Math.random() * (stage.stageWidth-2*ball.radius)+ball.radius;
				ball.y = Math.random() * (stage.stageHeight-2*ball.radius)+ball.radius;
				ball.vx = Math.random() * 8 - 4;
				ball.vy = Math.random() * 8 - 4;
				addChild(ball);
				balls.push(ball);
			}

			addEventListener(Event.ENTER_FRAME,onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			/*var totalMomentum:Number = 0;
			var totalKineticEnergy:Number = 0;*/

			for (var i:uint = 0; i<numBalls; i++)
			{
				var ball:Ball = balls[i];
				ball.x +=  ball.vx;
				ball.y +=  ball.vy;
				checkWalls(ball);
				var v = Math.sqrt(ball.vx * ball.vx + ball.vy * ball.vy);
				/*totalMomentum +=  ball.mass * v;
				totalKineticEnergy +=  ball.mass * v * v * 0.5;*/
			}
			//trace(totalMomentum, totalKineticEnergy);

			for (i = 0; i<numBalls-1; i++)
			{
				var ballA:Ball = balls[i];
				for (var j:uint = i+1; j<numBalls; j++)
				{
					var ballB:Ball = balls[j];
					checkCollision(ballA, ballB);
				}
			}
		}

		private function checkWalls(ball:Ball):void
		{
			if (ball.x + ball.radius > stage.stageWidth)
			{
				ball.x = stage.stageWidth - ball.radius;
				ball.vx *=  bounce;
			}
			else if (ball.x - ball.radius < 0)
			{
				ball.x = ball.radius;
				ball.vx *=  bounce;
			}
			if (ball.y + ball.radius > stage.stageHeight)
			{
				ball.y = stage.stageHeight - ball.radius;
				ball.vy *=  bounce;
			}
			else if (ball.y - ball.radius < 0)
			{
				ball.y = ball.radius;
				ball.vy *=  bounce;
			}
		}

		private function checkCollision(ball0:Ball,ball1:Ball):void
		{
			var dx:Number = ball1.x - ball0.x;
			var dy:Number = ball1.y - ball0.y;
			var dist:Number = Math.sqrt(dx * dx + dy * dy);
			if (dist < ball0.radius + ball1.radius)
			{

				// calculate angle, sine and cosine
				var angle:Number = Math.atan2(dy,dx);
				var sin:Number = Math.sin(angle);
				var cos:Number = Math.cos(angle);

				drawCoord(ball0,ball1, sin, cos);

				// rotate ball0's position
				//var x0:Number = 0;
				//var y0:Number = 0;
				var pos0:Point = new Point(0,0);

				// rotate ball1's position
				//var x1:Number = dx * cos + dy * sin;
				//var y1:Number = dy * cos - dx * sin;
				var pos1:Point = rotate(dx,dy,sin,cos,true);

				// rotate ball0's velocity
				//var vx0:Number = ball0.vx * cos + ball0.vy * sin;
				//var vy0:Number = ball0.vy * cos - ball0.vx * sin;
				var vel0:Point = rotate(ball0.vx,ball0.vy,sin,cos,true);

				// rotate ball1's velocity
				//var vx1:Number = ball1.vx * cos + ball1.vy * sin;
				//var vy1:Number = ball1.vy * cos - ball1.vx * sin;
				var vel1:Point = rotate(ball1.vx,ball1.vy,sin,cos,true);

				// collision reaction
				/*var vxTotal:Number = vx0 - vx1;
				vx0 = ball0.mass - ball1.mass * vx0 + 2 * ball1.mass * vx1 / ball0.mass + ball1.mass;
				vx1 = vxTotal + vx0;
				x0 +=  vx0;
				x1 +=  vx1;*/
				var vxTotal:Number = vel0.x - vel1.x;
				vel0.x = ((ball0.mass - ball1.mass) * vel0.x + 2 * ball1.mass * vel1.x) / (ball0.mass + ball1.mass);
				vel1.x = vxTotal + vel0.x;
				//update position. Causes balls to stick together
				//pos0.x +=  vel0.x;
				//pos1.x +=  vel1.x;
				//fix to sticking balls;
				var absV:Number = Math.abs(vel0.x) + Math.abs(vel1.x);
				var overlap:Number = (ball0.radius + ball1.radius) - Math.abs(pos0.x - pos1.x);
				pos0.x +=  vel0.x / absV * overlap;
				pos1.x +=  vel1.x / absV * overlap;


				// rotate positions back
				//var x0Final:Number = x0 * cos - y0 * sin;
				//var y0Final:Number = y0 * cos + x0 * sin;
				//var x1Final:Number = x1 * cos - y1 * sin;
				//var y1Final:Number = y1 * cos + x1 * sin;
				var pos0F:Object = rotate(pos0.x,pos0.y,sin,cos,false);
				var pos1F:Object = rotate(pos1.x,pos1.y,sin,cos,false);

				// adjust positions to actual screen positions
				//ball1.x = ball0.x + x1Final;
				//ball1.y = ball0.y + y1Final;
				//ball0.x = ball0.x + x0Final;
				//ball0.y = ball0.y + y0Final;
				ball1.x = ball0.x + pos1F.x;
				ball1.y = ball0.y + pos1F.y;
				ball0.x = ball0.x + pos0F.x;
				ball0.y = ball0.y + pos0F.y;

				// rotate velocities back
				/*ball0.vx = vx0 * cos - vy0 * sin;
				ball0.vy = vy0 * cos + vx0 * sin;
				ball1.vx = vx1 * cos - vy1 * sin;
				ball1.vy = vy1 * cos + vx1 * sin;*/
				var vel0F:Object = rotate(vel0.x,vel0.y,sin,cos,false);
				var vel1F:Object = rotate(vel1.x,vel1.y,sin,cos,false);

				ball0.vx = vel0F.x;
				ball0.vy = vel0F.y;
				ball1.vx = vel1F.x;
				ball1.vy = vel1F.y;
			}
		}

		private function rotate(x:Number, y:Number, sin:Number, cos:Number, reverse:Boolean):Point
		{
			var result:Point = new Point();
			if (reverse)
			{
				result.x = x * cos + y * sin;
				result.y = y * cos - x * sin;
			}
			else
			{
				result.x = x * cos - y * sin;
				result.y = y * cos + x * sin;
			}
			return result;
		}

		private function drawCoord(ballA:Ball, ballB:Ball, sin:Number, cos:Number)
		{
			/*var newColor = Math.random() * 0xFFFFFF;
			if (newColor < 0x888888) newColor *=  2;
			var myColor:ColorTransform = ballA.transform.colorTransform;
			myColor.color = newColor;*/
			var newColor = 0xFF0000;
			
			var myColor:ColorTransform = ballA.transform.colorTransform;
			myColor.color = newColor;

			ballA.transform.colorTransform = myColor;
			ballB.transform.colorTransform = myColor;

			TweenLite.to(ballA, 3, {tint:0xffffff});
			TweenLite.to(ballB, 3, {tint:0xffffff});
			
			//canvas.cacheAsBitmap = true;
			/*var xPos:Number = ballA.x + cos * ballA.radius;;
			var yPos:Number = ballA.y + sin * ballA.radius;
			//trace(xPos, yPos);
			var c:int = 25;//radius of circle around marked ball
			var g = canvas.graphics;
			g.clear();
			g.lineStyle(2*(ballA.radius + ballB.radius),newColor,0.2);
			g.moveTo(xPos,0);
			g.lineTo(xPos,stage.stageHeight);
			g.moveTo(0,yPos);
			g.lineTo(stage.stageWidth,yPos);*/
			//g.drawCircle(xPos,yPos,c);
		}
	}
}